/*
convert.c - audio(3) wants 44100hz, 2 channels, 16bit LE 2s complement int
Copyright (C) 2005 Sascha Retzki.
released under the terms of the MIT-License.
*/

#include <u.h>
#include <libc.h>

#include "libaudioconv.h"





/* Are there conversion-pairs which will overflow data(copy) buffer boundaries? */
void
convertsamplerate(short*data, short *datacopy, long insamplerate, long samplerate, long inbyterate)
{
	float  factor, counter = 0.0;
	long i, j = 0;


	memcpy(datacopy,data,inbyterate);
	memset(data,0,inbyterate);


	factor  =  (float)samplerate / (float)insamplerate;


	/* downsampling ... */
	if(insamplerate > samplerate) {


		for(i=0;i < inbyterate;i++) {

			counter += factor;

			if(counter >= 1.0) {
				data[j] = datacopy[i];

				j++;
				counter  -= 1.0;
			}

		}

	} else { /* upsampling... */

		for(i=0;i < inbyterate;i++) {

			while(counter > 0.0) {
				counter -= 1.0;

				data[j++] = datacopy[i];
			}


			counter += factor;
		}

	}


}


void
convertmono2stereo(short *data, short *datacopy, long byterate)
{
	long i, j = 0;



	memcpy(datacopy,data,byterate);


	for(i=0;i < byterate;i++) {

		/* mono to left ... */
		data[j++] = datacopy[i];

		/* mono to right ... */
		data[j++] = datacopy[i];

	}

}

/* converts 8bit unsigned to 16bit 2's complement */
void
convert8bitspersample(char *indata, short *outdata, long byterate)
{
	long i;

	for(i=0;i < byterate;i++) 
		outdata[i] = (indata[i] - 128) << 8;

}
